//+---------------------------------------------------------------+
//|                                Alternative_Ichimoku_v07.mq4   |
//|mtf:ForexTSD.com2007ml ki        Copyright  april 2007 v.07   |
//|                     Lukashuk Victor Gennadievich aka lukas1   |
//+---------------------------------------------------------------+
#property copyright "Copyright  2007, lukas1"
#property link ""
//----
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 MediumOrchid
#property indicator_color2 SlateBlue
//#property indicator_color3 LightPink
//#property indicator_color4 LightSteelBlue
#property indicator_color3 Blue
#property indicator_color4 DeepPink
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 2
#property indicator_width4 2
//---- input parameters
// bars - calculating period
extern int SSP = 34; 
// tolerance of second line
extern int SSK = 52; 
// do not show the middle line
extern bool Show_Middle = false; 
extern bool Show_Comment = true; 

extern int TimeFrame = 0;
extern string  note_TimeFrames = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";
string  IndicatorCorrectName;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//double Wal1[];
//double Wal2[];
double ExtMapBuffer4[], ExtMapBuffer5[];
int i, j;
double SsMax, SsMin, SsMax05, SsMin05, Rsmin, Rsmax, 
       Tsmin, Tsmax;
double Day_max, Day_min;
int val1, val2, AvgRange, day_bars, day_Range, 
    delta_from_max, delta_from_min, spred;
string comm, sutki;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(8);
//----
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexDrawBegin(0, SSP*2);
// priority line
   SetIndexLabel(0, "PriorityLine("+SSP+")["+TimeFrame+"]"); 
//----
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexDrawBegin(1, SSP*2);
// overdue line
   SetIndexLabel(1, "OverdueLine("+SSK+")["+TimeFrame+"]"); 
//----
//   SetIndexStyle(2, DRAW_HISTOGRAM);
//   SetIndexBuffer(2, Wal1);
 //  SetIndexDrawBegin(2,SSP*2);
//----
//   SetIndexStyle(3, DRAW_HISTOGRAM);
//   SetIndexBuffer(3, Wal2);
//   SetIndexDrawBegin(3,SSP*2);
//----
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, ExtMapBuffer4);
   SetIndexDrawBegin(2,SSP*2);
// stop-order line
   SetIndexLabel(3,"stop-order line"); 
//----      
   SetIndexStyle(3, DRAW_LINE);
   SetIndexBuffer(3, ExtMapBuffer5);
   SetIndexDrawBegin(3,SSP*2);
// middle line 
   SetIndexLabel(3,"middle line");      
//----
   IndicatorCorrectName = WindowExpertName();
        if (TimeFrame < Period()) TimeFrame = Period();

  IndicatorShortName("Alternative_Ichimoku_v07XM_mtf["+TimeFrame+"]");
        if (TimeFrame < Period()) TimeFrame = Period();
  return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() 
  {
   Comment("");
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   comm= ""; 
   int counted_bars=IndicatorCounted();
   int      limit,i;
   if(counted_bars < 0) return(-1);
   limit = Bars-counted_bars;
   if (TimeFrame != Period())
      {
         limit = MathMax(limit,TimeFrame/Period());
         datetime TimeArray[];
        ArrayCopySeries(TimeArray ,MODE_TIME ,NULL,TimeFrame);
            for(i=0,int y=0; i<limit; i++)
           {
              if(Time[i]<TimeArray[y]) y++;
              ExtMapBuffer1   [i]   = iCustom(NULL,TimeFrame,IndicatorCorrectName,SSP,SSK,Show_Middle,Show_Comment,0,y);
              ExtMapBuffer2   [i]   = iCustom(NULL,TimeFrame,IndicatorCorrectName,SSP,SSK,Show_Middle,Show_Comment,1,y);
   //           Wal1   [i1]   = iCustom(NULL,TimeFrame,IndicatorCorrectName,2,y);
   //           Wal2   [i1]   = iCustom(NULL,TimeFrame,IndicatorCorrectName,3,y);
              ExtMapBuffer4   [i]   = iCustom(NULL,TimeFrame,IndicatorCorrectName,SSP,SSK,Show_Middle,Show_Comment,2,y);
              ExtMapBuffer5   [i]   = iCustom(NULL,TimeFrame,IndicatorCorrectName,SSP,SSK,Show_Middle,Show_Comment,3,y);
            }
         return(0);         
      }
   
      if(Bars <= SSP + 1)
       return(0);
   i = Bars - SSP;
   while(i >= 0)
     {
       // RefreshRates();
       // maximum of previous SSP bars period
       SsMax = High[iHighest(NULL, 0, MODE_HIGH, SSP, i)];      
       // minimum of previous SSP bars period
       SsMin = Low[iLowest(NULL, 0, MODE_LOW, SSP, i)];         
       // maximum of SSP bars period for SSK bars from begin
       SsMax05 = High[iHighest(NULL, 0, MODE_HIGH, SSP, i + SSK)];
       // maximum of SSP bars period for SSK bars from begin
       SsMin05 = Low[iLowest(NULL, 0, MODE_LOW, SSP, i + SSK)];   
       ExtMapBuffer1[i] = (SsMax + SsMin) / 2;
       ExtMapBuffer2[i] = (SsMax05 + SsMin05) / 2;
       val1 = ExtMapBuffer1[1] / Point;
       val2 = ExtMapBuffer2[1] / Point;
       // for volatility
       Rsmax = High[iHighest(NULL, 0, MODE_HIGH, SSP*2, i)];
       // for volatility
       Rsmin = Low[iLowest(NULL, 0, MODE_LOW, SSP*2, i)];
       // histogram of a pink cloud
 //      Wal1[i] = ExtMapBuffer1[i]; 
       // histogram of a blue cloud
  //     Wal2[i] = ExtMapBuffer2[i]; 
       // stop-order line  
       Tsmax = High[iHighest(NULL, 0,MODE_HIGH, SSP*1.62, i)];   
       // stop-order line
       Tsmin = Low[iLowest(NULL, 0, MODE_LOW, SSP*1.62, i)];       
       ExtMapBuffer4[i] = (Tsmax + Tsmin) / 2;
       //----
       if(Show_Middle)
         {
           ExtMapBuffer5[i] = ((SsMax + SsMin) / 2 + 
                              (SsMax05 + SsMin05) / 2  ) / 2;
         }
       i--;
     }
   day_bars = MathCeil(1440 / Period());
   //if (Period()==1440) day_bars=5;
   sutki = "day";
   if(Period() == 1440)  
     {
       sutki = "week";
       day_bars = 5;
     }  // day
   if(Period() == 10080) 
     {
       sutki = "month"; 
       day_bars = 4;
     }  // week
   if(Period() == 43200) 
     {
       sutki = "year";  
       day_bars = 12;
     }  // month
   j = SSP*2 + 1;
   while(j >= 0)
     { 
       // find the daily range
       // max line of a day  
       Day_max = High[iHighest(NULL, 0,MODE_HIGH, day_bars, j + 1)];   
       // min line of a day
       Day_min = Low[iLowest(NULL, 0, MODE_LOW, day_bars, j + 1)];           
       j--;
     }      
   AvgRange = (Rsmax / Point) - (Rsmin / Point);
   day_Range = (Day_max / Point) - (Day_min / Point); 
   delta_from_max = (Day_max-Bid) / Point;
   delta_from_min = (Bid - Day_min) / Point;
//----

  
   comm = " parameters  SSP , SSK  =   " + SSP + " ,  " + SSK + " ;\n" +
          " TF ["+TimeFrame+"]; volatility  (on " + SSP*2 + " bars) :   " + 
          AvgRange + "  pp.\n" + //"\n" +
          " range for the " + sutki + "  (on  " + day_bars + 
          "  bars) :   " + day_Range + "  pp.\n" +
          " deviation from maximum for the " + sutki + ":  " + 
          delta_from_max + "  pp.\n" +
          " deviation from minimum  for the " + sutki + ":  " + 
          delta_from_min + "  pp.\n";            
  
  if (Show_Comment) 
      Comment(comm);
//----
   return(0);
  }
//+------------------------------------------------------------------+
/*
Pair Time SSP SSK
EURGBP 4H 44 38
CADCHF 4H 62 52
CADJPY 4H 48 36
GBPUSD 4H 44 36
GBPCHF 4H 34 29
GBPJPY 4H 36 29
EURUSD 4H 34 34
EURCHF 4H 72 50
EURJPY 4H 72 36
USDCAD 4H 24 60
USDCHF 4H 34 29
USDJPY 4H 34 29
*/